package xyz.etztech.core.maven;

import org.bukkit.plugin.java.JavaPlugin;

/**
 * Takes care of running the MavenLoader when the plugin is loaded.
 */
public class MavenPlugin extends JavaPlugin {

    // Allows plugins to still customize their load, enable, and disable methods

    /**
     * Allows a plugin to customize their onLoad method
     */
    protected void load() {}

    /**
     * Allows a plugin to customize their onEnable method
     */
    protected void enable() {}

    /**
     * Allows a plugin to customize their onDisable method
     */
    protected void disable() {}

    @Override
    public final void onLoad() {
        MavenLoader.loadAll(getClass());
        load();
    }

    @Override
    public final void onEnable() {
        enable();
    }

    @Override
    public final void onDisable() {
        disable();
    }

}
