package xyz.etztech.core;

import org.bukkit.Bukkit;
import org.bukkit.scheduler.BukkitScheduler;

import java.util.logging.Logger;

/**
 * A core set of Plugin utilities
 */
public class CoreUtils {

    private static final BukkitScheduler schedule = Bukkit.getScheduler();

    private static final Logger logger = Logger.getLogger("Minecraft");

    /**
     * @return The server scheduler
     */
    public static BukkitScheduler getSchedule() {
        return schedule;
    }

    /**
     * @return The Minecraft logger
     */
    public static Logger getLogger() {
        return logger;
    }

}
